#ifndef _GLUE_H_
#define _GLUE_H_

#include <glut.h>
#include <string>
using namespace std;

#define PIXELS 0
#define AXES   1
#define WINDOW 2

#define BLACK           0
#define RED             1
#define GREEN           2
#define YELLOW          3
#define BLUE            4
#define MAGENTA         5
#define CYAN            6
#define WHITE           7

#define GLUE_LEFT_BUTTON    GLUT_LEFT_BUTTON    
#define GLUE_MIDDLE_BUTTON   GLUT_MIDDLE_BUTTON  
#define GLUE_RIGHT_BUTTON  GLUT_RIGHT_BUTTON 

// mouse button callback state
#define GLUE_DOWN      GLUT_DOWN  
#define GLUE_UP        GLUT_UP 

// fonts
#define TIMES13       GLUT_BITMAP_8_BY_13   
#define TIMES10      GLUT_BITMAP_TIMES_ROMAN_10    
#define TIMES24      GLUT_BITMAP_TIMES_ROMAN_24 
#define HELVETICA10  GLUT_BITMAP_HELVETICA_10 
#define HELVETICA12  GLUT_BITMAP_HELVETICA_12 
#define HELVETICA24  GLUT_BITMAP_HELVETICA_18 

void keyboardfunction(void (* callback)( unsigned char, int, int ));
void mousefunction(void (*func)(int button, int state,
                                int x, int y));
void graphicsfunction(void (* callback)( int, int ));
void glueWindow(int width=640,int height=480,int xpos=50,int ypos=50, int color=WHITE, bool quitbutton=true);
void move(double, double, int coords=PIXELS);
void draw(double, double, int coords=PIXELS);
void filledrectangle(int x, int  y, int w, int h);
void filledcircle(int x, int  y, int r, int num_lines=100);
void glueGo();
void text(string txt, int x, int y, void* font=TIMES13) ;
void color(int);
void color(float,float, float);

void xaxis(float xlo, float xhi, int nxticks, float y, float ticksize,
           string title, float labello, float labelhi, int decplaces=2);
void yaxis(float ylo, float yhi, int nyticks, float x, float ticksize,
           string title, float labello, float labelhi, int decplaces=2);
int coordsystem(int);

#endif
